<?php

namespace FattorinoIt\Spedizione\Helper;
use \Magento\Framework\App\Helper\AbstractHelper;

class FattorinoItHelper extends AbstractHelper
{
  //const FIT_API_URL = "http://api.fattorino.ahlab/api/v2/";
  const FIT_API_URL = "https://api.fattorino.it/api/v2/";
  const FIT_HEADER_ACCESS = "fitaccess: 6aa425e73761777a7f9e07e773d7762a";


  public function getRates($shop, $address, $fitship)
  {

    $return = $this->callFattorino(json_encode(array('shop'=> $shop, 'postcode'=>$address['postcode'], 'fitship'=>$fitship)), 'get-rate-post-codes');
    if ($return_json = json_decode($return, true)) {
      if (isset($return_json['data']) && isset($return_json['data']['price'])){
        return  $return_json['data']['price'] ;
      }else {
        return false;
      }
    }
  }

  public function callFattorino($fields, $action)
  {
    $url = '/'.$action;
    $url = self::FIT_API_URL.$action;
    $json = json_encode($fields);

    $cu = curl_init($url);
    curl_setopt($cu, CURLOPT_POST, 1);
    curl_setopt($cu, CURLOPT_VERBOSE, TRUE);
    curl_setopt($cu, CURLOPT_HTTPHEADER, array(self::FIT_HEADER_ACCESS));
    curl_setopt($cu, CURLOPT_POSTFIELDS, "data=".$fields);
    curl_setopt($cu, CURLOPT_RETURNTRANSFER, true);
    $result = curl_exec($cu);

    curl_close($cu);
    return $result;
  }


  public function returnShippingAddressAssemble($shippingAddress)
  {
    $all = array();
    $all['firstname'] = $shippingAddress->getFirstname();
    $all['lastname'] = $shippingAddress->getLastname();
    $all['company'] = $shippingAddress->getCompany();
    $all['postcode'] = $shippingAddress->getPostCode();
    $all['city'] = $shippingAddress->getCity();
    $all['state'] = $shippingAddress->getRegion();
    $all['street'] = $shippingAddress->getStreet();
    $all['street1'] = $shippingAddress[0];
    $all['street2'] = $shippingAddress[1];
    $all['telephone'] = $shippingAddress->getTelephone();
    return $all;
  }


}
