define([
  'jquery',
  'ko',
  'Magento_Ui/js/form/element/abstract',
  'Magento_Checkout/js/model/quote',
  'Magento_Checkout/js/model/shipping-rate-processor/new-address',
  'Magento_Checkout/js/model/shipping-rate-processor/customer-address',
  'Magento_Checkout/js/model/shipping-rate-registry'
], function ($, ko, Component, quote, defaultProcessor, customerAddressProcessor, rateRegistry) {
  'use strict';

  return Component.extend({
    initialize: function () {
      this._super();
      var disabled = window.checkoutConfig.shipping.delivery_date.disabled;
      var noday = window.checkoutConfig.shipping.delivery_date.noday;
      var hourMin = parseInt(window.checkoutConfig.shipping.delivery_date.hourMin);
      var hourMax = parseInt(window.checkoutConfig.shipping.delivery_date.hourMax);
      var format = window.checkoutConfig.shipping.delivery_date.format;
      if(!format) {
        format = 'yy-mm-dd';
      }
      var disabledDay = disabled.split(",").map(function(item) {
        return parseInt(item, 10);
      });
      var time = unescape(this.getCookie('fitship')).split(" ");
      var startDate = this.getCookie('fitship') ? $.datepicker.formatDate('yy-mm-dd', new Date(unescape(this.getCookie('fitship'))))+" "+time[1] : '+1';
      console.log(startDate)
      ko.bindingHandlers.datetimepicker = {
        init: function (element, valueAccessor, allBindingsAccessor) {
          var $el = $(element);
          //initialize datetimepicker
          if(noday) {

            var options = {
              minDate: 0,
              defaultDate: startDate,
              dateFormat:format,
              onSelect : function(dateText, inst) {
                var exdate = new Date();
                exdate.setDate(exdate.getDate() + 1);
                var c_value = escape(dateText) + "; path=/;expires=" + exdate.toUTCString();
                document.cookie = "fitship=" + c_value;

                var processors = [];
                rateRegistry.set(quote.shippingAddress().getCacheKey(), null);
                processors.default =  defaultProcessor;
                processors['customer-address'] = customerAddressProcessor;
                var type = quote.shippingAddress().getType();
                if (processors[type]) {
                  processors[type].getRates(quote.shippingAddress());
                } else {
                  processors.default.getRates(quote.shippingAddress());
                }
              }
            };
          } else {
            var options = {
              minDate: 0,
              defaultDate: startDate,
              dateFormat:format,
              hourMin: hourMin,
              hourMax: hourMax,
              beforeShowDay: function(date) {
                var day = date.getDay();
                if(disabledDay.indexOf(day) > -1) {
                  return [false];
                } else {
                  return [true];
                }
              },
              onSelect : function(dateText, inst) {
                console.log(dateText)
              }
            };
          }

          $el.datetimepicker(options);
          $el.val(startDate);
          var writable = valueAccessor();
          if (!ko.isObservable(writable)) {
            var propWriters = allBindingsAccessor()._ko_property_writers;
            if (propWriters && propWriters.datetimepicker) {
              writable = propWriters.datetimepicker;
            } else {
              return;
            }
          }
          writable($(element).datetimepicker("getDate"));

        },
        update: function (element, valueAccessor) {
          var widget = $(element).data("DateTimePicker");
          //when the view model is updated, update the widget
          if (widget) {
            var date = ko.utils.unwrapObservable(valueAccessor());
            widget.date(date);
          }
        }
      };




      return this;
    },
    getCookie: function(nome){
      var name = nome + "=";
      var ca = document.cookie.split(';');
      for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ')
        c = c.substring(1);
        if (c.indexOf(name) == 0) return c.substring(name.length, c.length);
      }
      return "";
      return this;
    }
  });

});
